VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDeliveryNote"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3D3D582F02BC"
'<CAMH>****************************************************************************************
'* Module: cDeliveryNote
'* Date  : 15/08/02
'* Author: mauricem
'*$Archive: /Projects/OasysV2/VB/PurchaseOrderBO/DeliveryNote.cls $
'**********************************************************************************************
'* Summary: Business Object to wrap the functionality of a single Delivery Note
'**********************************************************************************************
'* $Author: Mauricem $
'* $Date: 2/28/03 4:07p $
'* $Revision: 8 $
'* Versions:
'* 15/08/02    mauricem
'*             Header added.
'</CAMH>***************************************************************************************
Option Base 0
Option Explicit

Const MODULE_NAME As String = "cDeliveryNote"
Const DOCTYPE_DELNOTE As Long = 0
Const DEL_NOTE_FILECODE As String = "SHRC"

Implements IBo
Implements ISysBo

Private m_oSession As Object

'##ModelId=3D3FE49F015E
Private mDocNo As String

'##ModelId=3D3FE4A9026C
Private mDocType As String

'##ModelId=3D3FE4B20208
Private mValue As Currency

'##ModelId=3D3FE4B502F8
Private mCost As Double

'##ModelId=3D3FE4B901EA
Private mDelNoteDate As Date

'##ModelId=3D3FE4C000C8
Private mComm As String

'##ModelId=3D3FE4C8010E
Private mOrigDocKey As Long

'##ModelId=3D3FE4D0030C
Private mEnteredBy As String

'##ModelId=3D3FE4D9023A
Private mComment As String

'##ModelId=3D3FE4DE01CC
Private mSupplierONumber As String

'##ModelId=3D3FE4F001E0
Private mConsignmentRef As String

'##ModelId=3D3FE5080172
Private mPONumber As String

'##ModelId=3D3FE5130352
Private mPODate As Date

'##ModelId=3D3FE519000A
Private mAssignedPORelease As String

'##ModelId=3D3FE5220122
Private mSOQControlNumber As String

'##ModelId=3D3FE5290258
Private mSupplierDelNote(9) As String

'##ModelId=3D3FE55D0154
Private mSource As String

'##ModelId=3D3FE56E01A4
Private mStoreNo As String

'##ModelId=3D3FE574015E
Private mIBT As String

'##ModelId=3D3FE5760294
Private mPrinted As Boolean

'##ModelId=3D3FE57A0262
Private mConsignmentKey As String

'##ModelId=3D3FE5840118
Private mSupplierNumber As String

'##ModelId=3D3FE589006E
Private mReturnDate As Date

'##ModelId=3D3FE596012C
Private mOrigPONumber As String

'##ModelId=3D3FE59D0032
Private mSupplierReturnNumber As String

'##ModelId=3D3FE5AD01D6
Private mInvCrnMatched As String

'##ModelId=3D3FE5B80190
Private mInvCrnDate As Date

'##ModelId=3D3FE5C200F0
Private mInvCrnNumber As String

'##ModelId=3D3FE5C901EA
Private mVarianceValue As Currency

'##ModelId=3D3FE5CD003C
Private mInvoiceValue As Currency

'##ModelId=3D3FE5D203A2
Private mInvoiceVAT As Currency

'##ModelId=3D3FE5D901D6
Private mMatchingComment As String

'##ModelId=3D3FE5E202EE
Private mMatchingDate As Date

'##ModelId=3D3FE5E802E4
Private mReceiptDate As Date

'##ModelId=3D3D583D0064
Private mCarraigeValue As Currency

'##ModelId=3D3D58460000
Private mCommit As String

Private mNarrative As String

Private mcolLines As Collection

Private mcolConsolLines As Collection 'local collection of Consolidated Purchase Order Lines

Private moRowSel As Object

Private moLoadRow As Object

Private mGetLines As Boolean
 
Private mintNarrStatus As Integer 'flag if narrative edited - -1 (Not Loaded), 0=Okay and 1 = Edited

Private mastrUpdatedLines() As String

Const NOT_LOADED As Long = -1
Const LOADED As Long = 0
Const EDITED As Long = 1


'##ModelId=3D5B74410032
Public Property Let Printed(ByVal Value As Boolean)
    Let mPrinted = Value
End Property

'##ModelId=3D5B744102C6
Public Property Get Printed() As Boolean
   Let Printed = mPrinted
End Property

Public Property Let Narrative(ByVal Value As String)
    mNarrative = Value
    mintNarrStatus = EDITED
End Property

Public Property Get Narrative() As String

Dim oDRLNarr As Object

    If mintNarrStatus = NOT_LOADED Then
        Set oDRLNarr = m_oSession.Database.createBusinessObject(CLASSID_DELNOTENARRATIVE)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_DocumentNumber, mDocNo)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_StoreNumber, m_oSession.CurrentEnterprise.IEnterprise_StoreNumber)
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_PartCode, "000000")
        Call oDRLNarr.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTENARRATIVE_SequenceNumber, "0000")
        Call oDRLNarr.IBo_Load
        mNarrative = oDRLNarr.NarrativeText1
        If oDRLNarr.NarrativeText2 <> "" Then mNarrative = mNarrative & vbCrLf & oDRLNarr.NarrativeText2
        Set oDRLNarr = Nothing
        mintNarrStatus = LOADED
    End If
    Narrative = mNarrative
    
End Property


'##ModelId=3D3D586E0136
Public Function AddItem(PartCode As String) As Object

Dim oLine As cPurchase.cDeliveryNoteLine

    Set oLine = m_oSession.Database.createBusinessObject(CLASSID_DELNOTELINE)
    Set oLine.DeliveryNote = Me
    oLine.PartCode = PartCode
    
    If mcolLines Is Nothing Then Set mcolLines = New Collection
    Call mcolLines.Add(oLine)
    oLine.LineNo = mcolLines.Count
    Set AddItem = oLine

End Function
        
'<CACH>****************************************************************************************
'* Sub:  MatchInvoice()
'**********************************************************************************************
'* Description:
'**********************************************************************************************
'* Parameters:
'*In/Out:StoreNumber    String.
'*In/Out:DocNumber  String.
'*In/Out:InvoiceNumber  String.
'*In/Out:SupplierCode   String.
'*In/Out:sref   String.
'*In/Out:sret   String.
'*In/Out:InvoiceDate    Date.
'*In/Out:MatchDate  Date.
'*In/Out:InvoiceValue   Double.
'*In/Out:InvoiceVATValue    Double.
'*In/Out:VarianceValue  Double.
'*In/Out:VarianceVATValue   Double.
'*In/Out:disp   Variant.
'**********************************************************************************************
'* History:
'* 22/01/03    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function MatchInvoice(StoreNumber As String, DocNumber As String, _
                             InvoiceNumber As String, SupplierCode As String, _
                             sref As String, sret As String, InvoiceDate As Date, _
                             MatchDate As Date, InvoiceValue As Double, _
                             InvoiceVATValue As Double, VarianceValue As Double, _
                             VarianceVATValue As Double, disp)

Dim oRow As Object

Const PROCEDURE_NAME As String = MODULE_NAME & ".MatchInvoice"
            
    'Check if document has been loaded
    If mDocNo <> DocNumber Then
        Call IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTEHEADER_DocNo, DocNumber)
        
        Call IBo_AddLoadField(FID_DELNOTEHEADER_InvCrnMatched)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_InvCrnNumber)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_InvCrnDate)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_VarianceValue)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_InvoiceValue)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_InvoiceVAT)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_DocNo)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_MatchingDate)
        Call IBo_AddLoadField(FID_DELNOTEHEADER_MatchingComment)
        
        Call IBo_Load
    End If
    
    'Update fields accordingly
    mInvCrnMatched = "M"
    mInvCrnNumber = InvoiceNumber
    mInvCrnDate = InvoiceDate
    mVarianceValue = VarianceValue
    mInvoiceValue = InvoiceValue
    mInvoiceVAT = InvoiceVATValue
    mMatchingDate = MatchDate

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_DELNOTEHEADER_InvCrnMatched))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_InvCrnNumber))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_InvCrnDate))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_VarianceValue))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_InvoiceValue))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_InvoiceVAT))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_DocNo))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_MatchingDate))
    Call oRow.Add(GetField(FID_DELNOTEHEADER_MatchingComment))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Function 'MatchInvoice

'##ModelId=3D3D58720258
Public Function DeleteItem(strLineNo As String, strPartCode As String) As Boolean

Dim lngItemNo As Long
Dim oLine     As cDeliveryNoteLine

    DeleteItem = False
    If mcolLines Is Nothing Then Exit Function
    'Find selected line in collection of lines
    Let strLineNo = Format(Val(strLineNo), "0000")
    For lngItemNo = 1 To mcolLines.Count Step 1
        If (mcolLines(lngItemNo).LineNo = strLineNo) And (mcolLines(lngItemNo).PartCode = strPartCode) Then
            Set oLine = mcolLines(lngItemNo)
            Exit For
        End If
    Next lngItemNo
    'check that line was found
    If oLine Is Nothing Then Exit Function
    'add updated line to list of lines to be updated to database
    ReDim Preserve mastrUpdatedLines(UBound(mastrUpdatedLines) + 1)
    lngItemNo = UBound(mastrUpdatedLines)
    mastrUpdatedLines(lngItemNo) = strLineNo
    'set quantity received to 0 to reverse out delivery
    oLine.ReceivedQty = 0
    DeleteItem = True
    
End Function

Public Function UpdateItemQuantity(strLineNo As String, strPartCode As String, dblQuantity As Double) As Boolean

Dim lngItemNo As Long
Dim oLine     As cDeliveryNoteLine

    UpdateItemQuantity = False
    If mcolLines Is Nothing Then Exit Function
    'Find selected line in collection of lines
    Let strLineNo = Format(Val(strLineNo), "0000")
    For lngItemNo = 1 To mcolLines.Count Step 1
        If (mcolLines(lngItemNo).LineNo = strLineNo) And (mcolLines(lngItemNo).PartCode = strPartCode) Then
            Set oLine = mcolLines(lngItemNo)
            Exit For
        End If
    Next lngItemNo
    'check that line was found
    If oLine Is Nothing Then Exit Function
    'add updated line to list of lines to be updated to database
    ReDim Preserve mastrUpdatedLines(UBound(mastrUpdatedLines) + 1)
    lngItemNo = UBound(mastrUpdatedLines)
    mastrUpdatedLines(lngItemNo) = strLineNo
    'set quantity received to 0 to reverse out delivery
    oLine.ReceivedQty = dblQuantity
    UpdateItemQuantity = True
    
End Function

'##ModelId=3D5B745602B2
Public Property Get Lines() As Collection
    If mcolLines Is Nothing Then
        Set mcolLines = New Collection
        If (mGetLines = True) Then Call RetrieveLines
    End If
    Set Lines = mcolLines
End Property

Private Sub RetrieveLines()

Dim oLine      As cDeliveryNoteLine
Dim lngLineNo  As Long

    'If Del Note found then get lines for Order
    Set mcolLines = New Collection
    Set oLine = m_oSession.Database.createBusinessObject(CLASSID_DELNOTELINE)
    Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_DELNOTELINE_DRLKey, mDocNo)
    Call oLine.IBo_AddLoadFilter(CMP_GREATERTHAN, FID_DELNOTELINE_LineNo, 0)
    Set mcolLines = oLine.IBo_LoadMatches
    For lngLineNo = 1 To mcolLines.Count Step 1
        Set mcolLines(lngLineNo).DeliveryNote = Me
    Next lngLineNo

End Sub
'##ModelId=3D5B745501A4
Public Property Get Commit() As String
   Let Commit = mCommit
End Property

'##ModelId=3D5B74540294
Public Property Let Commit(ByVal Value As String)
    Let mCommit = Value
End Property

'##ModelId=3D5B745400A0
Public Property Get CarraigeValue() As Currency
   Let CarraigeValue = mCarraigeValue
End Property

'##ModelId=3D5B74530186
Public Property Let CarraigeValue(ByVal Value As Currency)
    Let mCarraigeValue = Value
End Property

'##ModelId=3D5B74520384
Public Property Get ReceiptDate() As Date
   Let ReceiptDate = mReceiptDate
End Property

'##ModelId=3D5B74520082
Public Property Let ReceiptDate(ByVal Value As Date)
    Let mReceiptDate = Value
End Property

'##ModelId=3D5B745102B2
Public Property Get MatchingDate() As Date
   Let MatchingDate = mMatchingDate
End Property

'##ModelId=3D5B74500398
Public Property Let MatchingDate(ByVal Value As Date)
    Let mMatchingDate = Value
End Property

'##ModelId=3D5B745001AE
Public Property Get MatchingComment() As String
   Let MatchingComment = mMatchingComment
End Property

'##ModelId=3D5B744F02C6
Public Property Let MatchingComment(ByVal Value As String)
    Let mMatchingComment = Value
End Property

'##ModelId=3D5B744F00DC
Public Property Get InvoiceVAT() As Currency
   Let InvoiceVAT = mInvoiceVAT
End Property

'##ModelId=3D5B744E01F4
Public Property Let InvoiceVAT(ByVal Value As Currency)
    Let mInvoiceVAT = Value
End Property

'##ModelId=3D5B744E000A
Public Property Get InvoiceValue() As Currency
   Let InvoiceValue = mInvoiceValue
End Property

'##ModelId=3D5B744D00BE
Public Property Let InvoiceValue(ByVal Value As Currency)
    Let mInvoiceValue = Value
End Property

'##ModelId=3D5B744C0280
Public Property Get VarianceValue() As Currency
   Let VarianceValue = mVarianceValue
End Property

'##ModelId=3D5B744B0366
Public Property Let VarianceValue(ByVal Value As Currency)
    Let mVarianceValue = Value
End Property

'##ModelId=3D5B744B0172
Public Property Get InvCrnNumber() As String
   Let InvCrnNumber = mInvCrnNumber
End Property

'##ModelId=3D5B744A0294
Public Property Let InvCrnNumber(ByVal Value As String)
    Let mInvCrnNumber = Value
End Property

'##ModelId=3D5B744A00DC
Public Property Get InvCrnDate() As Date
   Let InvCrnDate = mInvCrnDate
End Property

'##ModelId=3D5B744901FE
Public Property Let InvCrnDate(ByVal Value As Date)
    Let mInvCrnDate = Value
End Property

'##ModelId=3D5B744803C0
Public Property Get InvCrnMatched() As String
   Let InvCrnMatched = mInvCrnMatched
End Property

'##ModelId=3D5B744800BE
Public Property Let InvCrnMatched(ByVal Value As String)
    Let mInvCrnMatched = Value
End Property

'##ModelId=3D5B744700C8
Public Property Get SupplierReturnNumber() As String
   Let SupplierReturnNumber = mSupplierReturnNumber
End Property

'##ModelId=3D5B744601AE
Public Property Let SupplierReturnNumber(ByVal Value As String)
    Let mSupplierReturnNumber = Value
End Property

'##ModelId=3D5B744503DE
Public Property Get OrigPONumber() As String
   Let OrigPONumber = mOrigPONumber
End Property

'##ModelId=3D5B74450118
Public Property Let OrigPONumber(ByVal Value As String)
    Let mOrigPONumber = Value
End Property

'##ModelId=3D5B74440348
Public Property Get ReturnDate() As Date
   Let ReturnDate = mReturnDate
End Property

'##ModelId=3D5B744400B4
Public Property Let ReturnDate(ByVal Value As Date)
    Let mReturnDate = Value
End Property

'##ModelId=3D5B744302E4
Public Property Get SupplierNumber() As String
   Let SupplierNumber = mSupplierNumber
End Property

'##ModelId=3D5B74430082
Public Property Let SupplierNumber(ByVal Value As String)
    Let mSupplierNumber = Value
End Property

'##ModelId=3D5B744202B2
Public Property Get ConsignmentKey() As String
   Let ConsignmentKey = mConsignmentKey
End Property

'##ModelId=3D5B7442005A
Public Property Let ConsignmentKey(ByVal Value As String)
    Let mConsignmentKey = Value
End Property

'##ModelId=3D5B74400294
Public Property Get IBT() As String
   Let IBT = mIBT
End Property

'##ModelId=3D5B7440003C
Public Property Let IBT(ByVal Value As String)
    Let mIBT = Value
End Property

'##ModelId=3D5B743F029E
Public Property Get StoreNo() As String
   Let StoreNo = mStoreNo
End Property

'##ModelId=3D5B743F0046
Public Property Let StoreNo(ByVal Value As String)
    Let mStoreNo = Value
End Property

'##ModelId=3D5B743E02B2
Public Property Get Source() As String
   Let Source = mSource
End Property

'##ModelId=3D5B743E008C
Public Property Let Source(ByVal Value As String)
    Let mSource = Value
End Property

'##ModelId=3D5B74370000
Public Property Get SupplierDelNote(Index As Variant) As String
   Let SupplierDelNote = mSupplierDelNote(Index)
End Property

'##ModelId=3D5B743601F4
Public Property Let SupplierDelNote(Index As Variant, ByVal Value As String)
    Let mSupplierDelNote(Index) = Value
End Property

'##ModelId=3D5B743600E6
Public Property Get SOQControlNumber() As String
   Let SOQControlNumber = mSOQControlNumber
End Property

'##ModelId=3D5B743502DA
Public Property Let SOQControlNumber(ByVal Value As String)
    Let mSOQControlNumber = Value
End Property

'##ModelId=3D5B74350190
Public Property Get AssignedPORelease() As String
   Let AssignedPORelease = mAssignedPORelease
End Property

'##ModelId=3D5B7434038E
Public Property Let AssignedPORelease(ByVal Value As String)
    Let mAssignedPORelease = Value
End Property

'##ModelId=3D5B74340276
Public Property Get PODate() As Date
   Let PODate = mPODate
End Property

'##ModelId=3D5B7434008C
Public Property Let PODate(ByVal Value As Date)
    Let mPODate = Value
End Property

'##ModelId=3D5B7433035C
Public Property Get PONumber() As String
   Let PONumber = mPONumber
End Property

'##ModelId=3D5B743301AE
Public Property Let PONumber(ByVal Value As String)
    Let mPONumber = Value
End Property

'##ModelId=3D5B74330064
Public Property Get ConsignmentRef() As String
   Let ConsignmentRef = mConsignmentRef
End Property

'##ModelId=3D5B74320294
Public Property Let ConsignmentRef(ByVal Value As String)
    Let mConsignmentRef = Value
End Property

'##ModelId=3D5B7432017C
Public Property Get SupplierONumber() As String
   Let SupplierONumber = mSupplierONumber
End Property

'##ModelId=3D5B743103AC
Public Property Let SupplierONumber(ByVal Value As String)
    Let mSupplierONumber = Value
End Property

'##ModelId=3D5B7431029E
Public Property Get Comment() As String
   Let Comment = mComment
End Property

'##ModelId=3D5B74310118
Public Property Let Comment(ByVal Value As String)
    Let mComment = Value
End Property

'##ModelId=3D5B7431000A
Public Property Get EnteredBy() As String
   Let EnteredBy = mEnteredBy
End Property

'##ModelId=3D5B7430026C
Public Property Let EnteredBy(ByVal Value As String)
    Let mEnteredBy = Value
End Property

'##ModelId=3D5B7430015E
Public Property Get OrigDocKey() As Long
   Let OrigDocKey = mOrigDocKey
End Property

'##ModelId=3D5B742F03CA
Public Property Let OrigDocKey(ByVal Value As Long)
    Let mOrigDocKey = Value
End Property

'##ModelId=3D5B742F02EE
Public Property Get Comm() As String
   Let Comm = mComm
End Property

'##ModelId=3D5B742F00FA
Public Property Let Comm(ByVal Value As String)
    Let mComm = Value
End Property

'##ModelId=3D5B742F001E
Public Property Get DelNoteDate() As Date
   Let DelNoteDate = mDelNoteDate
End Property

'##ModelId=3D5B742E028A
Public Property Let DelNoteDate(ByVal Value As Date)
    Let mDelNoteDate = Value
End Property

'##ModelId=3D5B742E0172
Public Property Get Cost() As Double
   Let Cost = mCost
End Property

'##ModelId=3D5B742E0028
Public Property Let Cost(ByVal Value As Double)
    Let mCost = Value
End Property

'##ModelId=3D5B742D0334
Public Property Get Value() As Currency
   Let Value = mValue
End Property

'##ModelId=3D5B742D01B8
Public Property Let Value(ByVal Value As Currency)
    Let mValue = Value
End Property

'##ModelId=3D5B742D00DC
Public Property Get DocType() As String
   Let DocType = mDocType
End Property


'##ModelId=3D5B742C029E
Public Property Get DocNo() As String
   Let DocNo = mDocNo
End Property


'##ModelId=3D5B742C0154
Public Property Let DocNo(ByVal Value As String)
    Let mDocNo = Value
End Property

Public Property Get GetLines() As Boolean
   Let GetLines = mGetLines
End Property

Public Property Let GetLines(ByVal Value As Boolean)
    Let mGetLines = Value
End Property

Public Function ConsolidationLines() As Collection

Dim oLine As cPurchase.cPurchaseConsLine

    If (mcolConsolLines Is Nothing) Then
        'if consolidation lines not loaded then get from database
        Set mcolConsolLines = New Collection
        Set oLine = m_oSession.Database.createBusinessObject(CLASSID_PURCHASECONSLINE)
        Call oLine.IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASECONSLINE_PurchaseOrderNumber, mOrigPONumber)
        Set mcolConsolLines = oLine.IBo_LoadMatches
    End If
    Set ConsolidationLines = mcolConsolLines
    
End Function
'<CACH>****************************************************************************************
'* Function:  Boolean LoadFromRow()
'**********************************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a row of field and
'*              for this object to extract the data and populate the properties of the object.
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   Object. - collection of fields
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 15/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function LoadFromRow(oRow As Object) As Boolean

Dim lFieldNo As Integer
Dim oField   As Object

Const PROCEDURE_NAME As String = MODULE_NAME & ".LoadFromRow"

    mintNarrStatus = NOT_LOADED
    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        Select Case (oField.IField_Id)
            Case (FID_DELNOTEHEADER_DocNo):            mDocNo = oField.StringValue
            Case (FID_DELNOTEHEADER_DocType):          mDocType = oField.StringValue
            Case (FID_DELNOTEHEADER_Value):            mValue = oField.DoubleValue
            Case (FID_DELNOTEHEADER_Cost):             mCost = oField.DoubleValue
            Case (FID_DELNOTEHEADER_DelNoteDate):      mDelNoteDate = oField.DateValue
            Case (FID_DELNOTEHEADER_Comm):             mComm = oField.StringValue
            Case (FID_DELNOTEHEADER_OrigDocKey):       mOrigDocKey = oField.LongValue
            Case (FID_DELNOTEHEADER_EnteredBy):        mEnteredBy = oField.StringValue
            Case (FID_DELNOTEHEADER_Comment):          mComment = oField.StringValue
            Case (FID_DELNOTEHEADER_SupplierONumber):  mSupplierONumber = oField.StringValue
            Case (FID_DELNOTEHEADER_ConsignmentRef):   mConsignmentRef = oField.StringValue
            Case (FID_DELNOTEHEADER_PONumber):         mPONumber = oField.StringValue
            Case (FID_DELNOTEHEADER_PODate):           mPODate = oField.DateValue
            Case (FID_DELNOTEHEADER_AssignedPORelease): mAssignedPORelease = oField.StringValue
            Case (FID_DELNOTEHEADER_SOQControlNumber): mSOQControlNumber = oField.StringValue
            Case (FID_DELNOTEHEADER_SupplierDelNote):  Call LoadStringArray(mSupplierDelNote, oField, m_oSession)
            Case (FID_DELNOTEHEADER_Source):           mSource = oField.StringValue
            Case (FID_DELNOTEHEADER_StoreNo):          mStoreNo = oField.StringValue
            Case (FID_DELNOTEHEADER_IBT):              mIBT = oField.StringValue
            Case (FID_DELNOTEHEADER_Printed):          mPrinted = oField.BoolValue
            Case (FID_DELNOTEHEADER_ConsignmentKey):   mConsignmentKey = oField.StringValue
            Case (FID_DELNOTEHEADER_SupplierNumber):   mSupplierNumber = oField.StringValue
            Case (FID_DELNOTEHEADER_ReturnDate):       mReturnDate = oField.DateValue
            Case (FID_DELNOTEHEADER_OrigPONumber):     mOrigPONumber = oField.StringValue
            Case (FID_DELNOTEHEADER_SupplierReturnNumber): mSupplierReturnNumber = oField.StringValue
            Case (FID_DELNOTEHEADER_InvCrnMatched):    mInvCrnMatched = oField.StringValue
            Case (FID_DELNOTEHEADER_InvCrnDate):       mInvCrnDate = oField.DateValue
            Case (FID_DELNOTEHEADER_InvCrnNumber):     mInvCrnNumber = oField.StringValue
            Case (FID_DELNOTEHEADER_VarianceValue):    mVarianceValue = oField.DoubleValue
            Case (FID_DELNOTEHEADER_InvoiceValue):     mInvoiceValue = oField.DoubleValue
            Case (FID_DELNOTEHEADER_InvoiceVAT):       mInvoiceVAT = oField.DoubleValue
            Case (FID_DELNOTEHEADER_MatchingComment):  mMatchingComment = oField.StringValue
            Case (FID_DELNOTEHEADER_MatchingDate):     mMatchingDate = oField.DateValue
            Case (FID_DELNOTEHEADER_ReceiptDate):      mReceiptDate = oField.DateValue
            Case (FID_DELNOTEHEADER_CarraigeValue):    mCarraigeValue = oField.DoubleValue
            Case (FID_DELNOTEHEADER_Commit):           mCommit = oField.StringValue
            Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow



Private Sub Class_Initialize()
    
    Call DebugMsg(MODULE_NAME, "Initialise", endlTraceIn)
    mDocType = 0
    ReDim mastrUpdatedLines(0)
    
End Sub

Private Function IBo_CreateNew() As Object

    Set IBo_CreateNew = New cDeliveryNote

End Function

Private Property Get IBo_DebugString() As String
    
    IBo_DebugString = "Delivery Note - " & mDocNo

End Property

Private Function IBo_GetField(nFid As Long) As Object

    Set IBo_GetField = GetField(nFid)

End Function

Private Function IBo_GetSelectAllRow() As Object
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

Private Function Initialise(oSession As Object) As cDeliveryNote
    Set m_oSession = oSession
    Set Initialise = Me
End Function
Private Function IBo_Initialise(oSession As Object) As Object
    
    Set IBo_Initialise = Initialise(oSession)

End Function

Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_DELNOTEHEADER

End Property

Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

Public Function IBo_Load() As Boolean
    
    IBo_Load = Load

End Function
Private Function Load() As Boolean
    
Dim oView       As Object
    
    Load = False
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.Merge(GetSelectAllRow)
        
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(moRowSel)
    If Not (oView Is Nothing) Then
        If oView.Count >= 1 Then Load = LoadFromRow(oView.Row(1))
    End If

End Function

Private Function ISysBo_LoadFromRow(oRow As Object) As Boolean
    
    Call LoadFromRow(oRow)

End Function

Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & App.Revision

End Property


Public Function GetField(lFieldID As Long) As Object

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    Select Case (lFieldID)
        Case (FID_DELNOTEHEADER_DocNo):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mDocNo
        Case (FID_DELNOTEHEADER_DocType):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mDocType
        Case (FID_DELNOTEHEADER_Value):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mValue
        Case (FID_DELNOTEHEADER_Cost):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mCost
        Case (FID_DELNOTEHEADER_DelNoteDate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mDelNoteDate
        Case (FID_DELNOTEHEADER_Comm):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mComm
        Case (FID_DELNOTEHEADER_OrigDocKey):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldLong")
                    GetField.LongValue = mOrigDocKey
        Case (FID_DELNOTEHEADER_EnteredBy):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mEnteredBy
        Case (FID_DELNOTEHEADER_Comment):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mComment
        Case (FID_DELNOTEHEADER_SupplierONumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mSupplierONumber
        Case (FID_DELNOTEHEADER_ConsignmentRef):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mConsignmentRef
        Case (FID_DELNOTEHEADER_PONumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mPONumber
        Case (FID_DELNOTEHEADER_PODate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mPODate
        Case (FID_DELNOTEHEADER_AssignedPORelease):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mAssignedPORelease
        Case (FID_DELNOTEHEADER_SOQControlNumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mSOQControlNumber
        Case (FID_DELNOTEHEADER_SupplierDelNote):  Set GetField = SaveStringArray(mSupplierDelNote, m_oSession)
        Case (FID_DELNOTEHEADER_Source):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mSource
        Case (FID_DELNOTEHEADER_StoreNo):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mStoreNo
        Case (FID_DELNOTEHEADER_IBT):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mIBT
        Case (FID_DELNOTEHEADER_Printed):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldBool")
                    GetField.BoolValue = mPrinted
        Case (FID_DELNOTEHEADER_ConsignmentKey):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mConsignmentKey
        Case (FID_DELNOTEHEADER_SupplierNumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mSupplierNumber
        Case (FID_DELNOTEHEADER_ReturnDate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mReturnDate
        Case (FID_DELNOTEHEADER_OrigPONumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mOrigPONumber
        Case (FID_DELNOTEHEADER_SupplierReturnNumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mSupplierReturnNumber
        Case (FID_DELNOTEHEADER_InvCrnMatched):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mInvCrnMatched
        Case (FID_DELNOTEHEADER_InvCrnDate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mInvCrnDate
        Case (FID_DELNOTEHEADER_InvCrnNumber):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mInvCrnNumber
        Case (FID_DELNOTEHEADER_VarianceValue):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mVarianceValue
        Case (FID_DELNOTEHEADER_InvoiceValue):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mInvoiceValue
        Case (FID_DELNOTEHEADER_InvoiceVAT):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mInvoiceVAT
        Case (FID_DELNOTEHEADER_MatchingComment):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mMatchingComment
        Case (FID_DELNOTEHEADER_MatchingDate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mMatchingDate
        Case (FID_DELNOTEHEADER_ReceiptDate):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDate")
                    GetField.DateValue = mReceiptDate
        Case (FID_DELNOTEHEADER_CarraigeValue):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldDouble")
                    GetField.DoubleValue = mCarraigeValue
        Case (FID_DELNOTEHEADER_Commit):
                    Set GetField = m_oSession.Root.CreateUtilityObject("CFieldString")
                    GetField.StringValue = mCommit
    End Select
    
    If Not GetField Is Nothing Then GetField.IField_Id = lFieldID

End Function

Private Function GetSelectAllRow() As Object
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_DELNOTEHEADER, FID_DELNOTEHEADER_END_OF_STATIC, m_oSession)

End Function

Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

Public Function IBo_SaveIfNew() As Boolean

    If mStoreNo = "" Then mStoreNo = "000"
    If mIBT = "" Then mIBT = "000000"
    If mConsignmentKey = "" Then mConsignmentKey = "000000"
    If mSupplierNumber = "" Then mSupplierNumber = "  000"
    If mOrigPONumber = "" Then mOrigPONumber = "000000"
    If mStoreNo = "" Then mStoreNo = "000"
    If mSupplierReturnNumber = "" Then mSupplierReturnNumber = "000000"
    If mOrigPONumber = "" Then mOrigPONumber = "000000"
    If mSupplierNumber = "" Then mSupplierNumber = "  000"
    IBo_SaveIfNew = Save(SaveTypeIfNew)

End Function

Public Function IBo_SaveIfExists() As Boolean

    IBo_SaveIfExists = Save(SaveTypeIfExists)

End Function

Public Function IBo_Delete() As Boolean

    IBo_Delete = Save(SaveTypeDelete)

End Function

Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function


Private Function Save(eSave As enSaveType) As Boolean
' Save all properties to the database
Dim lLineNo   As Long
Dim oPOrder   As cPurchaseOrder
Dim oPOLine   As cPurchaseLine
Dim oDelLine  As cDeliveryNoteLine
Dim oConHdr   As cConsignmentHeader
Dim oNarr     As cDelNoteNarrative
Dim oSysNum   As Object
Dim oSupplier As cSupplier
    
    Save = False
    
    mDocType = 0
    
    If IsValid() Then
        If eSave = SaveTypeIfNew Then
            'Get Next Purchase Order Number
            Set oSysNum = m_oSession.Database.createBusinessObject(CLASSID_SYSTEMNO)
            mDocNo = oSysNum.GetNewReceiptNumber
            Set oSysNum = Nothing
           
            'Create a Consigment Record to point to Delivery Note
            Set oConHdr = m_oSession.Database.createBusinessObject(CLASSID_CONSHEADER)
            oConHdr.PurchaseOrderNo = mPONumber
            oConHdr.PurchaseOrderRelNo = Val(mAssignedPORelease)
            oConHdr.ConsignmentDate = mDelNoteDate
            oConHdr.SupplierNo = mSupplierONumber
            For lLineNo = 1 To 9 Step 1
                oConHdr.DeliveryNoteNo(lLineNo) = mSupplierDelNote(lLineNo)
            Next lLineNo
            Call oConHdr.IBo_SaveIfNew
            
            ' Get a row and pass it to the database to insert/update/delete
            mConsignmentRef = oConHdr.ConsignmentNo
        End If
        Save = m_oSession.Database.SaveBo(eSave, Me)
        
        If eSave = SaveTypeIfNew Then
            'Get Purchase Order to update quantities for
            Set oPOrder = m_oSession.Database.createBusinessObject(CLASSID_PURCHASEORDER)
            Call oPOrder.IBo_AddLoadFilter(CMP_EQUAL, FID_PURCHASEORDER_Key, mOrigDocKey)
            oPOrder.GetAllLines = True
            Call oPOrder.IBo_Load
        
            'Save each line for the Delivery Note
            For lLineNo = 1 To mcolLines.Count Step 1
                Set oDelLine = mcolLines(CLng(lLineNo))
                oDelLine.DRLKey = Me.DocNo
                Call oDelLine.IBo_SaveIfNew
                'After saving line - Update Purchase Order Line if required
                If oDelLine.POLineNumber > 0 Then Call oPOrder.RecordItemDelivered(oDelLine.POLineNumber, oDelLine.ReceivedQty, mDocNo, oDelLine.LineNo, oDelLine.ToFollowQty)
            Next lLineNo
        Else
            'First save all edited line to the database
            For lLineNo = 1 To UBound(mastrUpdatedLines) Step 1
                Set oDelLine = mcolLines(CLng(mastrUpdatedLines(lLineNo)))
                Call oDelLine.IBo_SaveIfExists
            Next lLineNo
            'Step through list of lines and if none have the DRLKey then Save as new
            For lLineNo = 1 To mcolLines.Count Step 1
                Set oDelLine = mcolLines(CLng(lLineNo))
                If oDelLine.DRLKey = "" Then
                    oDelLine.DRLKey = Me.DocNo
                    Call oDelLine.IBo_SaveIfNew
                 End If
            Next lLineNo
        End If
        
        If (eSave = SaveTypeIfNew) Then
            Set oSupplier = m_oSession.Database.createBusinessObject(CLASSID_SUPPLIER)
            Call oSupplier.RecordDelivery(mSupplierONumber, mDelNoteDate, CDbl(mValue), oPOrder.ReceivedAll)
            If mNarrative <> "" Then 'if narrative captured then call sub BO to save
                Set oNarr = m_oSession.Database.createBusinessObject(CLASSID_DELNOTENARRATIVE)
                oNarr.DocumentNumber = mDocNo
                If InStr(mNarrative, vbCrLf) > 0 Then
                    If InStr(mNarrative, vbCrLf) > 1 Then
                        oNarr.NarrativeText1 = Left$(mNarrative, InStr(mNarrative, vbCrLf) - 1)
                    End If
                    oNarr.NarrativeText2 = Mid$(mNarrative, InStr(mNarrative, vbCrLf) + 2)
                Else
                    oNarr.NarrativeText1 = mNarrative
                    oNarr.NarrativeText2 = ""
                End If
                oNarr.StoreNumber = m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
                oNarr.PartCode = "000000"
                oNarr.SequenceNumber = "0000"
                Call oNarr.IBo_SaveIfNew
                Set oNarr = Nothing
            End If
        End If
        If ((oPOrder Is Nothing) = False) Then
            If oPOrder.ReceivedAll = False Then Call oPOrder.IncrementReleaseNumber 'Increment and Save Release Number
        End If
    End If

End Function

Private Function Delete() As Boolean
    Debug.Assert False
End Function

Private Function IsValid() As Boolean
'    Debug.Assert False
    IsValid = True
End Function


Private Function GetAllFieldsAsRow() As Object
' Returns a CRow object containing one field object for each property.
    
Dim oRow    As Object
Dim nFid    As Long
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    For nFid = (CLASSID_DELNOTEHEADER * &H10000) + 1 To FID_DELNOTEHEADER_END_OF_STATIC Step 1
        oRow.Add GetField(nFid)
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function

'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection criteria before
'*              calling the IBo_Load method.  This appends the selection criteria to the
'*              oRowSel object which is used by the IBo_Load method.
'**********************************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'*In/Out:Value  Variant. - Value that Field will be compared to
'**********************************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'**********************************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As Object

Const PROCEDURE_NAME As String = MODULE_NAME & ".IBo_AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    oField.IField_ValueAsVariant = Value
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.AddSelection(Comparator, oField)
    IBo_AddLoadFilter = True

End Function 'IBo_AddLoadFilter



'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadField()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up all fields that must be returned
'*              when using the LoadMatches method.  This appends the field to the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is populated.
'**********************************************************************************************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'**********************************************************************************************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub IBo_AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".IBo_AddLoadField"
    
    'Add field to Row selector
    If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'IBo_AddLoadField

Public Sub IBo_ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

Public Sub IBo_ClearLoadField()

    Set moLoadRow = Nothing

End Sub

Public Function IBo_LoadMatches(Optional oReturnRow As Object = Nothing) As Collection

' Load up all properties from the database
Dim oField      As Object
Dim oView       As Object
Dim colBO       As Collection
Dim oBO         As Object
Dim lBONo       As Long
Dim oLoadFields As Object
    
    Set colBO = New Collection
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = m_oSession.Root.CreateUtilityObject("CRowSelector")
    
    'Add in default Document type filter
    Set oField = GetField(FID_DELNOTEHEADER_DocType)
    oField.IField_ValueAsVariant = DOCTYPE_DELNOTE
    Call oLoadFields.AddSelection(CMP_EQUAL, oField)
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.createBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            Call colBO.Add(oBO)
        Next lBONo
    End If
    
    Set IBo_LoadMatches = colBO

End Function


Private Function IBo_Interface(Optional eInterfaceType As Long) As Object

    

End Function

Public Function IBo_GetAllFieldsAsRow() As Object
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_DELNOTEHEADER_END_OF_STATIC

End Function


Public Function CreateFile()

Const PROCEDURE_NAME = MODULE_NAME & ".CreateFile"

Const EDI_NA As String = ""

Dim oRowSel     As Object
Dim oField      As Object
Dim strHeader   As String
Dim strTrailer  As String
Dim lngLineNo   As Long
Dim strLine     As String
Dim oFSO        As FileSystemObject
Dim tsOrder     As TextStream
Dim strFilename As String
Dim dteNA       As Date
Dim mStoreNumber As String
Dim oFileNo     As Object
Dim oLine       As Object

On Error GoTo Bad_CreateFile

    'Create field for storing Key into
    Set oField = GetField(FID_DELNOTEHEADER_DocNo)
    If oField Is Nothing Then Exit Function
    
    'Add field to Row selector
    Set oRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call oRowSel.AddSelection(CMP_EQUAL, oField)
    
    If mstrDateFmt = "" Then mstrDateFmt = UCase$(m_oSession.GetParameter(PRM_EDI_DATE_FMT))
    
    strFilename = m_oSession.GetParameter(PRM_EDIPATH)
    If (Right$(strFilename, 1) <> "\") Then strFilename = strFilename & "\"
    
    Set oFSO = New FileSystemObject
    If oFSO.FolderExists(strFilename) = False Then Call Err.Raise(OASYS_ERR_INVALID_EDI_PATH, PROCEDURE_NAME, "Unable to locate EDI path - " & strFilename)
    
    Set oFileNo = m_oSession.Database.createBusinessObject(CLASSID_EDIFILECONTROL)
    Call oFileNo.IBo_AddLoadFilter(CMP_EQUAL, FID_EDIFILECONTROL_FileCode, DEL_NOTE_FILECODE)
    Call oFileNo.IBo_LoadMatches
    
    strHeader = "HR" & Format(Now(), "DD/MM/YY HH:NN:SS") & " " & oFileNo.LastSequenceNo & " " & Format(Lines.Count + 1, "000000") & " " & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
        
    'Build file name to save data into
    strFilename = strFilename & "SHRC" & oFileNo.LastSequenceNo & "." & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
    
    Call DebugMsg(MODULE_NAME, "CreateFile", endlDebug, "DRL SUM OUT File=" & strFilename)
    Set tsOrder = oFSO.CreateTextFile(strFilename, False)
    Call tsOrder.WriteLine(strHeader)

'    Call tsOrder.WriteLine("DS," & m_oSession.Database.GetLiteralView(oRowSel, 2, vbCrLf, ",", ""))
    tsOrder.Write "DS," & mDocNo & "," & mDocType & "," & mValue & "," & mCost & "," & FormatEDIDate(mDelNoteDate) & ","
'   ds:numb,ds:type,ds:valu,ds:cost,ds:date
    tsOrder.Write mOrigDocKey & "," & mEnteredBy & "," & mComment & "," & mSupplierONumber & ","
'   ds:tkey,ds:init,ds:info,e ds:0sup wsup,wsup
    tsOrder.Write mConsignmentRef & "," & mPONumber & "," & FormatEDIDate(mPODate) & "," & mAssignedPORelease & ","
'   ds:0con,ds:0pon,ds:0dat,ds:0rel
    tsOrder.Write mSOQControlNumber & ","
'   ds:0soq
    For lngLineNo = 1 To 9 Step 1
        tsOrder.Write mSupplierDelNote(lngLineNo) & ","
    Next lngLineNo
'   ds:0dl1,ds:0dl2,ds:0dl3,ds:0dl4,ds:0dl5,ds:0dl6,ds:0dl7,ds:0dl8,ds:0dl9
    tsOrder.Write mSource & "," & mStoreNo & "," & mIBT & ","
'   ds:0src,ds:1str,ds:1ibt
    If mPrinted = True Then
        tsOrder.Write "Y"
    Else
        tsOrder.Write "N"
    End If
    tsOrder.Write "," & mConsignmentKey & "," & mSupplierNumber & "," & FormatEDIDate(dteNA) & "," & mOrigPONumber & ","
'   ds:1prt,ds:1con,  e   ds:3sup   wsup,,wsup,ds:3dat,ds:3pon,ds:3ret
    tsOrder.Write mSupplierReturnNumber & "," & mInvCrnMatched & "," & FormatEDIDate(mInvCrnDate) & "," & mInvCrnNumber & "," & mVarianceValue & ","
'   ds:matf,ds:idat,ds:invn,rvrv
    tsOrder.Write mInvoiceValue & "," & mInvoiceVAT & "," & mMatchingComment & "," & FormatEDIDate(mMatchingDate) & "," & FormatEDIDate(mReceiptDate) & ","
'   ds:ival,ds:ivat,memo,ds:mdat,ds:tdat
    tsOrder.WriteLine mCarraigeValue & "," & mCommit
'   ds:carval,canc-ist?

    
    For lngLineNo = 1 To Lines.Count Step 1
        Set oLine = mcolLines(CLng(lngLineNo))
        
        tsOrder.Write "DD," & oLine.DRLKey & "," & oLine.LineNo & "," & oLine.PartCode & "," & oLine.PartCodeAlphaCode
'dd:numb,dd:seqn,dd:skun,dd:alph
        tsOrder.Write "," & oLine.OrderQty & "," & oLine.ReceivedQty & "," & oLine.OrderPrice & "," & oLine.BlanketDiscDesc
'dd:ordq'dd:recq'dd:ordp'dd:bdes
        tsOrder.Write "," & oLine.BlanketPartCode & "," & oLine.CurrentPrice & "," & oLine.CurrentCost & "," & oLine.IBTQuantity
'dd:bspc'dd:pric'dd:Cost'dd:ibtq
        tsOrder.Write "," & oLine.ReturnQty & "," & oLine.ToFollowQty & "," & oLine.ReturnReasonCode & "," & oLine.POLineNumber & ","
'dd:retq,'dd:folq'dd:reas'dd:poln
        If oLine.Checked = True Then
            tsOrder.Write "Y"
        Else
            tsOrder.Write "N"
        End If
'dd:ichk
        tsOrder.WriteLine "," & oLine.SinglesSellingUnit
'dd:qpsu

    Next lngLineNo
    
    If mNarrative <> "" Then
        tsOrder.Write "DN" & "," & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber
        tsOrder.WriteLine "," & mDocNo & ",0000," & mNarrative
    End If
    
    For lngLineNo = 1 To Lines.Count Step 1
        Set oLine = mcolLines(CLng(lngLineNo))
        If oLine.Narrative <> "" Then
            tsOrder.Write "DN" & "," & m_oSession.CurrentEnterprise.IEnterprise_StoreNumber & ","
            tsOrder.WriteLine oLine.DRLKey & "," & oLine.LineNo & "," & oLine.PartCode & "," & mNarrative
        End If
    Next lngLineNo
    
    strTrailer = "TR"
    Call tsOrder.WriteLine(strTrailer)
    
    Call tsOrder.Close
    
    CreateFile = True
    
    Exit Function
    
Bad_CreateFile:

    CreateFile = False
    Call Err.Raise(Err.Number, Err.Source, Err.Description)
    
End Function


